#include <amxmodx>
#include <csstats>

#define IGNORE_FLAG ADMIN_LEVEL_H	// flag "t"

new pRanks, pFlags
new g_TopPrefix[33]

public plugin_init() {
	register_plugin( "Top Awards", "0.11h", "Safety1st" )
	register_dictionary( "topawards.txt" )
	pRanks = register_cvar( "top_ranks", "10" )
	pFlags = register_cvar( "top_flags", "rmno" )
}

public client_putinserver(id) {
	set_task( 0.3, "CheckStats", id )	// we need to use delay otherwise we will get rank = 0
}

public plugin_natives()
	register_native("get_user_topvip", "native_user_topvip", 1);

public native_user_topvip(id)
{
	return g_TopPrefix[id];
}

public CheckStats(id) {
	new iFlags = get_user_flags(id)
	new szAddFlags[16]
	get_pcvar_string( pFlags, szAddFlags, 15 )
	new iAddFlags  = read_flags(szAddFlags)
	
	if ( iFlags & IGNORE_FLAG || iFlags & iAddFlags == iAddFlags )
		// ignore player with IGNORE_FLAG or having all additional flags
		return

	new iRanks = get_pcvar_num(pRanks)
	if ( !iRanks )
		return

	new szStats[8], szBodyHits[8]
	new iRank = get_user_stats( id, szStats, szBodyHits )

	if ( iRank && iRank <= iRanks ) 
	{
		g_TopPrefix[id] = true
		// 1st check for safety. may be player not ranked at all yet
		set_user_flags( id, iFlags | iAddFlags )
		new data[2]
		data[0] = id
		data[1] = iRanks
		set_task( 5.0, "PrintMessage", _, data, 2 )
	}
}

public PrintMessage( data[2] ) {
	if ( !is_user_connected(data[0]) )
		return

	set_dhudmessage( random(200) + 25, random(200) + 25, random(200) + 25, -1.0, 0.75, 0, .fxtime = 2.0, .holdtime = 10.0 )
	show_dhudmessage( data[0], "%L", data[0], "TOP_AWARDS", data[1] )
}